<?php /* task board Components*/ ?>
<template id="boards-template">
  <div>
    <div class="wpsContent wps_no_padding padding-20">
        <?php $dttTaskFunObj->__defaultMethod = "GET";echo $dttTaskFunObj->postUrlUsingCurl(DTT_API_URL.'api/template?temp=boards');?>
        <?php //echo file_get_contents(API_URL.'api/template?temp=boards');?>
    </div>
    <model-popup v-if="showPayModal" :class="showPayModal?'show':''" @close="hidePayModel">
        <span slot="close" class="wps-inline-modal-close" @click.prevent="hidePayModel">&times;</span>
        <h4 slot="header" class="wps-inline-modal-title"><?= __("Approve Task",DTT_TEXT_DOMAIN)?></h4>
        <div slot="body">
            <form method="post" id="frmWpsAddTask">
                <div class="wps-form-msg"></div>
                <table>
                    <tr>
                        <td>
                            <table class="wpsTaskAddTbl">
                                <tr>
                                    <td width="100%" colspan="2">
                                        <div class="extra-fields"> 
                                            <div class="extra-container">
                                                <label class="pull-left task-name">
                                                    {{ tasks[itemIndex].name }}
                                                </label>
                                            </div>
                                        </div>
                                        <div class="clear"></div>
                                    </td>
                                </tr>
                                <tr>
                                    <td width="30%">
                                        <div class="extra-fields">
                                            <div class="extra-container">
                                                <label class="pull-left">
                                                    <?= __("Task Total",DTT_TEXT_DOMAIN)?>
                                                </label>
                                            </div>
                                        </div>
                                        <div class="clear"></div>
                                    </td>
                                    <td width="30%">
                                        <div class="extra-fields"> 
                                            <div class="extra-container">
                                                <label class="pull-left">
                                                    {{ tasks[itemIndex].price|showPriceFormat(currency) }}
                                                </label>
                                            </div>
                                        </div>
                                        <div class="clear"></div>
                                    </td>
                                </tr>

                                <tr>
                                    <td width="30%"> 
                                        <div class="extra-fields">
                                            <div class="extra-container">
                                                <label class="pull-left">
                                                    <?= __("Account Balance",DTT_TEXT_DOMAIN)?>
                                                </label>
                                            </div>
                                        </div>
                                        <div class="clear"></div>
                                    </td>
                                    <td width="30%">
                                        <div class="extra-fields"> 
                                            <div class="extra-container">
                                                <label class="pull-left">
                                                    {{ walletBalance|showPriceFormat(currency) }}
                                                </label>
                                            </div>
                                        </div>
                                        <div class="clear"></div>
                                    </td>
                                </tr>

                                <tr>
                                    <td width="30%"> 
                                        <div class="extra-fields">
                                            <div class="extra-container">
                                                <label class="pull-left">
                                                    <?= __("Payable",DTT_TEXT_DOMAIN)?>
                                                </label>
                                            </div>
                                            <div class="clear"></div>
                                        </div>
                                    </td>
                                    <td> 
                                        <div class="extra-fields">
                                            <div class="extra-container">
                                                <label class="pull-left">
                                                    <span v-if="walletBalance >= tasks[itemIndex].price">{{currency+'0.00'}}</span>
                                                    <span v-else-if="walletBalance <= 0">{{ (tasks[itemIndex].price)|showPriceFormat(currency) }}</span>
                                                    <span v-else-if="walletBalance < tasks[itemIndex].price">{{ (tasks[itemIndex].price-walletBalance)|showPriceFormat(currency) }}</span>

                                                </label>
                                                <div class="clear"></div>    
                                            </div>
                                            <span class="remaining-amt">
                                                <i v-if="walletBalance >= tasks[itemIndex].price">({{tasks[itemIndex].price|showPriceFormat(currency)}} <?= __("will be deducted from your balance ",DTT_TEXT_DOMAIN);?> {{ (walletBalance)|showPriceFormat(currency) }}.)</i>
                                                <i v-else-if="walletBalance <= 0">(<?= __("You don't have sufficient balance to pay from your Wallet.",DTT_TEXT_DOMAIN);?>)</i>
                                                <i v-else-if="walletBalance < tasks[itemIndex].price">
                                                    ({{ walletBalance|showPriceFormat(currency) }} <?= __("will be deducted from your balance, You have to pay only ",DTT_TEXT_DOMAIN);?> {{(tasks[itemIndex].price)-walletBalance|showPriceFormat(currency)}}.)</i>
                                            </span>    
                                        </div>                                        
                                    </td>
                                </tr>
                            </table>                        
                        </td>
                    </tr> 
                    <tr>
                        <td>
                            <div class="wps_imgSubmit d-inline-block"  v-if="walletBalance >= tasks[itemIndex].price">
                                <button type="button" v-on:click.prevent="payWithWallet(itemIndex)" class="wpsSubmitBtn">
                                    <img src="<?= DTT_ASSETS .( 'images/right-arrow.png' );?>" alt="arrow"> <?= __("Pay with Paypal ",DTT_TEXT_DOMAIN);?>{{currency+'0'}}
                                </button>
                            </div>
                            <div class="wps_imgSubmit d-inline-block paypal_btn_wrapper"  v-else="">
                                <div class="paypal-btn wpsSubmitBtn">
                                    <a data-balloon-length="large" data-balloon="<?= __( 'Pay to worker so worker can start working on that task', DTT_TEXT_DOMAIN ) ?>" 
                                data-balloon-pos="up" href="javascript:void(0);" class="d-inline-block">
                                        <span class="wps_paypal_icon">
                                            <img src="<?= DTT_ASSETS .( 'images/paypal.png' );?>"> <?= __( 'Pay with Paypal ', DTT_TEXT_DOMAIN ) ?>{{(tasks[itemIndex].price)-walletBalance|showPriceFormat(currency)}}
                                        </span>
                                     </a>
                                    <paypal-checkout
                                        :amount="$options.filters.priceFormat(tasks[itemIndex].price-walletBalance)"
                                        :currency="currency_code"
                                        :env="env"
                                        :client="paypal"
                                        :button-style="aStyle"
                                        :experience="experienceOptions"
                                        :items="getPaypalItem(tasks[itemIndex],walletBalance)"
                                        v-on:payment-authorized="paymentAuthorized"
                                        v-on:payment-completed="paymentCompleted"
                                        v-on:payment-cancelled="paymentCancelled">
                                    </paypal-checkout>
                                </div>
                            </div>                    
                            <div class="wps_imgSubmit d-inline-block">
                                <button v-if="config.subscription" type="button" class="wpsSubmitBtn" v-on:click.prevent="hidePayModel">
                                    <img src="<?= DTT_ASSETS .( 'images/right-arrow.png' );?>" alt="arrow"> <?= __("Pay in next cycle",DTT_TEXT_DOMAIN)?>
                                </button>
                                <a v-else="" class="wpsSubmitBtn d-inline-block" href="<?= admin_url( 'admin.php?page=dtt_task_manager_settings#app-settings' ) ?>"> 
                                    <img src="<?= DTT_ASSETS .( 'images/right-arrow.png' );?>" alt="arrow"> <?= __("Setup Subscription Plan",DTT_TEXT_DOMAIN)?> 
                                </a>
                            </div>
                        </td>
                    </tr>
                    <tr>
                        <td scope="row">
                             <table class="wpsTaskAddTbl">
                                <tr>
                                    <td class="pay-content">
                                    <span><b><?= __("Note",DTT_TEXT_DOMAIN)?> :</b></span>
                            <?= __("If your task amount is less then wallet amount in that case , task amount will be deducted from wallet. If your task amount is greater then wallet amount in that case you will have to pay complete task amount from paypal or will postpond later for next billing cycle.",DTT_TEXT_DOMAIN);?>
                                </td>
                            </tr>
                        </table>
                            
                        </td>
                    </tr>
                    
                </table>            
                <br>
                <div class="clear"></div>
            </form>
        </div>
    </model-popup>
  </div>
</template>